
// Project: ITVeVe 85x48 v3 
// Created: 2019-01-11

// show all errors
SetErrorMode(2)

//include
#include "menu.agc"
#include "functions.agc"

// set window properties
SetWindowTitle( "ITVeVe 85x48 v3" )
SetWindowSize( 85*10, 48*10, 1 )
SetWindowAllowResize( 1 ) // allow the user to resize the window

// set display properties
SetVirtualResolution( 85, 48 ) // doesn't have to match the window
SetOrientationAllowed( 1, 1, 1, 1 ) // allow both portrait and landscape on mobile devices
SetSyncRate( 10, 0 ) // 30fps instead of 60 to save battery
SetScissor( 0,0,0,0 ) // use the maximum available screen space, no black borders
SetDefaultMagFilter(0) // toto je potrebne aby sa
SetDefaultMinFilter(0) // pixely nerozmazavali

//globals
global font
global ghost1:global ghost2:global ghost3
global gx:global gy:global gx2:global gy2:global gx3:global gy3
global smerg:global smerg2:global smerg3
font=LoadImage("alphabet.png")
SetTextDefaultFontImage(font)
dim map$[27,24]
dim tile[27,24]

do
	menu()
	rules()
	px=17
	py=2
	gx=41
	gy=22
	gx2=41
	gy2=24
	gx3=41
	gy3=24
	x=15
	y=0
	cx=15:cy=0
	win=0
	gameover=0
	pacman_img=loadimage("pacman.png")
	ghost1_img=loadimage("ghost1.png")
	ghost2_img=loadimage("ghost2.png")
	ghost3_img=loadimage("ghost3.png")
	sprite=LoadImage("block.png")
	pickup_img=loadimage("pickup.png")
	file=OpenToRead("lvl.txt")
	while FileEOF(file)=0
		line$=ReadLine(file)
		for i=1 to len(line$)
			c$=mid(line$,i,1)
			if c$="O"
				spr=createsprite(sprite)
				SetSpritePosition(spr,x,y)
				setspriteshape(spr,2)
			endif
			
			if c$="X"
				spr=createsprite(pickup_img)
				SetSpritePosition(spr,cx,cy)
				setspriteshape(spr,3)
				SetSpriteColorAlpha(spr,185)
			endif
			
			map$[(cx-15)/2,cy/2]=c$
			tile[(cx-15)/2,cy/2]=spr
			
			inc x,2
			inc cx,2
			
		next
		x=15
		cx=15
		inc y,2
		inc cy,2
	endwhile

	pacman=createsprite(pacman_img)
	ghost1=createsprite(ghost1_img)
	ghost2=createsprite(ghost2_img)
	ghost3=createsprite(ghost3_img)
	heart=loadsprite("heart.png")
	setspriteposition(heart,1,2)
	lives_str=createtext("3")
	settextposition(lives_str,7,3)
	smerg=3
	smerg2=3
	smerg3=3
	novy_smer=0
	smer=0
	score=0
	lives=3
	repeat
		settextstring(lives_str,str(lives))
		ppx=px
		ppy=py

		if GetRawKeyState(39) 
			smer=0
		endif
		if getrawkeystate(37) //and r2=0
			smer=1
		endif
		if GetRawKeyState(38) //and r3=0
			smer=2
		endif
		if getrawkeystate(40) //and r4=0
			smer=3
		endif
		x=(px-15)/2
		y=py/2
		if smer=0 and map$[x+1,y]<>"O"
			px=px+2
		endif
		if smer=3 and map$[x,y+1]<>"O"
			py=py+2
		endif

		if smer=1 and map$[x-1,y]<>"O"
			px=px-2
		endif
		if smer=2 and map$[x,y-1]<>"O"
			py=py-2
		endif
		
		SetSpritePosition(pacman,px,py)
		if map$[x,y]="X"
			if GetSpriteExists(tile[x,y])
				deletesprite(tile[x,y])
				score=score+1
			endif
		endif
		movementofghosts()
		
		/*
		print(map$[x,y])
		print(tile[x,y])
		*/
		/*
		score_txt=createtext("SCORE ")
		settextposition(score_txt,0,0)
		scr=createtext("0")
		SetTextPosition(scr,10,0)
		settextstring(scr,str(score))
		*/
		/*
		elseif map$[x,y]="O"
			px=ppx
			py=ppy
			setspriteposition(pacman,px,py)
		endif
		*/
			if GetSpriteCollision(pacman,ghost1) or getspritecollision(pacman,ghost2) or getspritecollision(pacman,ghost3) 
			lives=lives-1
			px=17
			py=2
			gx=41
			gy=22
			gx2=41
			gy2=24
			gx3=41
			gy3=24
			setspriteposition(pacman,px,py)
			setspriteposition(ghost1,gx,gy)
			setspriteposition(ghost2,gx2,gy2)
			setspriteposition(ghost3,gx3,gy3)
			smerg=3
			smerg2=3
			smerg3=3
			smer=0
		endif
		if score=282
			win=1
		endif
		if lives=0
			gameover=1
		endif
		sync()
	until win=1 or gameover=1
	deleteallsprites()
	deletealltext()
	if win=1
		win()
		repeat
			if GetVirtualButtonExists(1) and GetVirtualButtonPressed(1)
				end
			endif
			if GetVirtualButtonExists(2) and GetVirtualButtonPressed(2)
				cont=1
			endif
			sync()
		until cont=1
		deleteallsprites()
		deletealltext()
		DeleteVirtualButton(1)
		deletevirtualbutton(2)
		win=0
		cont=0
	endif
	if gameover=1
		lose()
		repeat
			if GetVirtualButtonExists(1) and GetVirtualButtonPressed(1)
				end
			endif
			if GetVirtualButtonExists(2) and GetVirtualButtonPressed(2)
				cont=1
			endif
			sync()
		until cont=1
		deleteallsprites()
		deletealltext()
		DeleteVirtualButton(1)
		deletevirtualbutton(2)
		gameover=0
		cont=0
		Sync()
	endif
loop
